{% load static %}

<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

<!-- Bootstrap -->
<link rel="stylesheet" href="{% static 'libraries/bootstrap.min.css' %}">

<!-- Jquery -->
<script src="{% static 'libraries/jquery-3.4.1.min.js' %}"></script>
<script src="{% static 'libraries/popper.min.js' %}"></script>
<script src="{% static 'libraries/bootstrap.min.js' %}"></script>
<script src="{% static 'libraries/js.cookie.min.js' %}"></script>
<!-- <script src="https://cdn.jsdelivr.net/npm/js-cookie@2/src/js.cookie.min.js"></script> -->

<script type="text/javascript">
  $( document ).ready( function (){
    // fix de bootstrap (custom-file-label)
    $('.custom-file-input').on('change',function(){
      var fileName = $(this).val().split('\\').pop();
      $(this).next('.custom-file-label').html(fileName);
    })

    // activacion de tooltips
    $('[data-toggle="tooltip"]').tooltip()

    // permitir tabulacion en textarea's
    $("textarea").keydown(function(e) {
      if(e.keyCode === 9) { // tab was pressed
        // get caret position/selection
        var start = this.selectionStart;
            end = this.selectionEnd;

        var $this = $(this);

        // set textarea value to: text before caret + tab + text after caret
        $this.val($this.val().substring(0, start)
                    + "\t"
                    + $this.val().substring(end));

        // put caret at right position again
        this.selectionStart = this.selectionEnd = start + 1;

        // prevent the focus lose
        return false;
      }
    });

    // sobreescritura de alert.alert('close')
    // $('#alert_notification').on('close.bs.alert', function (e) {
    //   e.preventDefault();
    //   $(this).removeClass('visible');
    //   $(this).addClass('hidden');
    // });

    {% if messages %}{% for message in messages %}
    push_alert('{{message|safe}}', 'alert-{{message.tags}}');
    {% endfor %}{% endif %}
  });

  var csrftoken = getCookie('csrftoken');
  
  function csrfSafeMethod(method) {
    // these HTTP methods do not require CSRF protection
    return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
  }
  $.ajaxSetup({
    beforeSend: function(xhr, settings) {
      if (!csrfSafeMethod(settings.type) && !this.crossDomain) {
        xhr.setRequestHeader("X-CSRFToken", csrftoken);
      }
    }
  });

  function getCookie(name) {
    var cookieValue = null;
    if (document.cookie && document.cookie !== '') {
      var cookies = document.cookie.split(';');
      for (var i = 0; i < cookies.length; i++) {
        var cookie = cookies[i].trim();
        // Does this cookie string begin with the name we want?
        if (cookie.substring(0, name.length + 1) === (name + '=')) {
          cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
          break;
        }
      }
    }
    return cookieValue;
  }

  function toggle_chevron(elem, option = undefined){
    if (option=='right'){
      $(elem).children(".down").hide()
      $(elem).children(".right").show()
    }
    else if (option=='down'){
      $(elem).children(".right").hide()
      $(elem).children(".down").show()
    }
    else{
      if ($(elem).hasClass("collapsed")){
        $(elem).children(".right").hide()
        $(elem).children(".down").show()
      }

      else if (!$(elem).hasClass("collapsed") && option!='down'){
        $(elem).children(".down").hide()
        $(elem).children(".right").show()
      }
    }
  }

  function getValue(object, key){
    if (typeof(object)=='object' && key in object){
      return object[key];
    }
    else{
      return ''
    }
  }

  function toogle_test_status(elem, test_type, test_id){
    {% if test_executed %}
    let jquery_elem = $(elem) 
    let new_status = ''
    if (jquery_elem.hasClass('in-construction')){
      new_status = 'built'
    }
    else{
      new_status = 'inConstruction'
    }

    $.ajax({
      url: '/'+test_type+'/status/update/'+test_id,
      type: 'POST',
      data: {
        'status': new_status,
      },
      success: function(result){
        if (new_status == 'built'){
          jquery_elem.removeClass('in-construction');
          jquery_elem.attr('data-original-title', "Marcar prueba como 'En construcción'");
          jquery_elem.addClass('built');
          jquery_elem.text('Construida');
          push_alert('Pruba marcada correctamente como "Construida"', 'alert-success');
        }
        else{
          jquery_elem.removeClass('built');
          jquery_elem.attr('data-original-title', "Marcar prueba como 'Construida'");
          jquery_elem.addClass('in-construction');
          jquery_elem.text('En construcción');
          push_alert('Pruba marcada correctamente como "En construcción"', 'alert-success');
        }
      },
      error: function(result){
        console.log(result);
        alert('Ocurrió un error inesperado al cambiar el estado de la prueba actual');
      }
    });
    {% else %}
    push_alert('Error: La prueba debe ejecutarse al menos 1 vez para poder marcase como "Construida"', 'alert-danger')
    {% endif %}

  }

  function start_unsaved_changes_messages(){
    window.onbeforeunload = function(event) {
      if (localStorage.getItem("changes")=="true"){
        localStorage.clear()
        setTimeout(function() {
          setTimeout(function() {
            localStorage.setItem("changes", true);
          },500);
        },1);
        return 1;
      }
    }

    $('textarea, input, select').change(() => {
      unsaved_changes();
      // localStorage.setItem("changes", true);
    })
    $('#new-test input.form-control, #new-test select.custom-select, #add-section input.form-control').unbind();
  }

  function unsaved_changes(){
    save = $('#save_test');
    save.removeClass('btn-outline-info');
    save.addClass('btn-info');

    execute = $('#execute_test');
    execute.removeClass('btn-info');
    execute.addClass('btn-outline-info');

    localStorage.setItem("changes", true);
  }

  function push_alert(message, style='alert-success'){
    if (style == 'alert-error'){
      style = 'alert-danger'
    }
    let alert_element = $('#alert_notification').clone();
    alert_element.addClass('alert_notification');
    top_shifted = 20;
    $('.alert_notification').each((i, elem)=>{
      // aqui sumar el heigth + 20 a top_shifted
      top_shifted = top_shifted + elem.offsetHeight + 20
    });

    alert_element.css('top', top_shifted+"px");
    let parent = $('#alert_notification').parent();

    alert_element.children('.text-content').html(message);
    alert_element.show();
    alert_element.removeClass('alert-success alert-warning alert-danger alert-primary alert-secondary alert-info alert-light alert-dark').addClass(style);
    alert_element.on('close.bs.alert', function (e) {
      e.preventDefault();
      $(this).removeClass('visible');
      $(this).addClass('hidden');
      setTimeout(()=>{
        $(this).remove();
      }, 400);
    });

    parent.append(alert_element);

    setTimeout(()=>{
      alert_element.removeClass('hidden').addClass('visible');

      close_timer_id = setTimeout(()=>{
        alert_element.alert('close');
      }, 5000)
      alert_element.attr('id', close_timer_id)
      // console.log('created timer '+close_timer_id)

      alert_element.mouseover(()=>{
        alert_element.unbind();
        close_timer_id = alert_element.attr('id')
        clearTimeout(close_timer_id);
        console.log("timer "+close_timer_id+" detenido")
      })
    }, 1) //para que aparezca la animacion
  }

  function loading_message(message){
    push_alert(message+' <div class="spinner-border text-info ml-2" role="status" style="width: 1.2rem; height: 1.2rem;"> <span class="sr-only">Loading...</span> </div>', 'alert-secondary');
  }
</script>

{{'base.scss'|css_compiler|safe}}

<div id="alert_notification" style="display: none;" class="alert alert-success alert-dismissible hidden mb-0" role="alert">
  <div class="text-content">
  </div>
  <button type="button" class="close" data-dismiss="alert" aria-label="Close">
    <span aria-hidden="true">&times;</span>
  </button>
</div>
